# smach< CON, K, M >::event_def_internal< T > Class Template Reference

Event definition class. More...

`#include <_smach.h>`

List of all members.

## Public Types

typedef T | state_context_type
typedef event_result(T::* | funcptr )(const event &)
| Event function type.

## Public Member Functions

bool | operator< (const event_def_internal &rhs) const
| Less-than operator for sorting. Based on event_key value.
bool | operator== (const event_def_internal &rhs) const
| Equal-to operator. Based on event_key value.
bool | operator< (const event_key &rhs) const
| Less-than operator for finding.
bool | operator== (const event_key &rhs) const
| Equal-to operator. Based on event_key value.
| event_def_internal ()
| Trivial Constructor.
| event_def_internal (event_key a, funcptr b)
| Constructor for creating an event_def_internal from the given key and function reference.
| event_def_internal (const event_def_internal &x)
| Copy constructor.

## Public Attributes

event_key | id
funcptr | handler

## Friends

class | smach

## Detailed Description

### template<typename CON, typename K = int, typename M = mutex_null>
template<typename T>
class smach< CON, K, M >::event_def_internal< T >

Event definition class.

Definition at line 102 of file _smach.h.

## Member Typedef Documentation

template<typename CON, typename K = int, typename M = mutex_null>
template<typename T>

typedef T smach< CON, K, M >::event_def_internal< T >::state_context_type

Definition at line 109 of file _smach.h.

template<typename CON, typename K = int, typename M = mutex_null>
template<typename T>

typedef event_result(T::* smach< CON, K, M >::event_def_internal< T >::funcptr)(const event &)

Event function type.

## Constructor & Destructor Documentation

template<typename CON, typename K = int, typename M = mutex_null>
template<typename T>

smach< CON, K, M >::event_def_internal< T >::event_def_internal | ( |  | ) | `[inline]`

Trivial Constructor.

Definition at line 138 of file _smach.h.

template<typename CON, typename K = int, typename M = mutex_null>
template<typename T>

smach< CON, K, M >::event_def_internal< T >::event_def_internal | ( | event_key | a,
|  | funcptr | b |
| ) |  |  | `[inline]`

Constructor for creating an event_def_internal from the given key and function reference.

Definition at line 141 of file _smach.h.

template<typename CON, typename K = int, typename M = mutex_null>
template<typename T>

smach< CON, K, M >::event_def_internal< T >::event_def_internal | ( | const event_def_internal< T > & | x | ) | `[inline]`

Copy constructor.

Definition at line 144 of file _smach.h.

## Member Function Documentation

template<typename CON, typename K = int, typename M = mutex_null>
template<typename T>

bool smach< CON, K, M >::event_def_internal< T >::operator< | ( | const event_def_internal< T > & | rhs | ) | const`[inline]`

Less-than operator for sorting. Based on event_key value.

Definition at line 122 of file _smach.h.

References smach< CON, K, M >::event_def_internal< T >::id.

template<typename CON, typename K = int, typename M = mutex_null>
template<typename T>

bool smach< CON, K, M >::event_def_internal< T >::operator== | ( | const event_def_internal< T > & | rhs | ) | const`[inline]`

Equal-to operator. Based on event_key value.

Definition at line 126 of file _smach.h.

References smach< CON, K, M >::event_def_internal< T >::id.

template<typename CON, typename K = int, typename M = mutex_null>
template<typename T>

bool smach< CON, K, M >::event_def_internal< T >::operator< | ( | const event_key & | rhs | ) | const`[inline]`

Less-than operator for finding.

Definition at line 130 of file _smach.h.

template<typename CON, typename K = int, typename M = mutex_null>
template<typename T>

bool smach< CON, K, M >::event_def_internal< T >::operator== | ( | const event_key & | rhs | ) | const`[inline]`

Equal-to operator. Based on event_key value.

Definition at line 134 of file _smach.h.

## Friends And Related Function Documentation

template<typename CON, typename K = int, typename M = mutex_null>
template<typename T>

friend class smach `[friend]`

Definition at line 105 of file _smach.h.

## Member Data Documentation

template<typename CON, typename K = int, typename M = mutex_null>
template<typename T>

event_key smach< CON, K, M >::event_def_internal< T >::id

Definition at line 116 of file _smach.h.

Referenced by smach< CON, K, M >::state< T >::insert(), smach< CON, K, M >::event_def_internal< T >::operator<(), and smach< CON, K, M >::event_def_internal< T >::operator==().

template<typename CON, typename K = int, typename M = mutex_null>
template<typename T>

funcptr smach< CON, K, M >::event_def_internal< T >::handler

Definition at line 117 of file _smach.h.

The documentation for this class was generated from the following file:

- _smach.h